org.eclipse.ecf.provider.remoteservice.generic

## Class RemoteServiceContainer

- java.lang.Object
- - org.eclipse.ecf.core.AbstractContainer
  - - org.eclipse.ecf.provider.generic.SOContainer
    - - org.eclipse.ecf.provider.generic.ClientSOContainer
      - - org.eclipse.ecf.provider.generic.TCPClientSOContainer
        - - org.eclipse.ecf.provider.remoteservice.generic.RemoteServiceContainer

All Implemented Interfaces:
  org.eclipse.core.runtime.IAdaptable, IContainer, IIdentifiable, IReliableContainer, ISharedObjectContainer, ISharedObjectContainerClient, IRemoteServiceConsumer, IRemoteServiceContainerAdapter, IRemoteServiceHost

    public class RemoteServiceContainer
    extends TCPClientSOContainer
    implements IRemoteServiceContainerAdapter

### Field Summary

Fields
`protected IRemoteServiceContainerAdapter` `registry`

### Fields inherited from class org.eclipse.ecf.provider.generic.TCPClientSOContainer

`DEFAULT_COMM_NAME, DEFAULT_TCP_CONNECT_TIMEOUT`

### Fields inherited from class org.eclipse.ecf.provider.generic.ClientSOContainer

`CONNECTED, CONNECTING, connection, connectionState, connectLock, connectPolicy, DEFAULT_CONNECT_TIMEOUT, DISCONNECTED, remoteServerID`

### Fields inherited from class org.eclipse.ecf.provider.generic.SOContainer

`config, DEFAULT_OBJECT_ARG_KEY, DEFAULT_OBJECT_ARGTYPES_KEY, groupManager, isClosing, loadingThreadGroup, policy, receiver, sharedObjectManager, sharedObjectMessageSerializer, sharedObjectThreadGroup`

### Constructor Summary

Constructors
Constructor and Description
`RemoteServiceContainer(ISharedObjectContainerConfig config)`
`RemoteServiceContainer(ISharedObjectContainerConfig config, int ka)`

### Method Summary

All Methods Instance Methods Concrete Methods
`void` `addRemoteServiceListener(IRemoteServiceListener listener)` Add listener for remote service registration/unregistration for this container
`org.eclipse.equinox.concurrent.future.IFuture` `asyncGetRemoteServiceReferences(ID[] idFilter, String clazz, String filter)` Asynchronously returns an array of `IRemoteServiceReference` objects.
`org.eclipse.equinox.concurrent.future.IFuture` `asyncGetRemoteServiceReferences(ID target, ID[] idFilter, String clazz, String filter)` Asynchronously returns an array of `IRemoteServiceReference` objects.
`org.eclipse.equinox.concurrent.future.IFuture` `asyncGetRemoteServiceReferences(ID target, String clazz, String filter)` Asynchronously returns an array of `IRemoteServiceReference` objects.
`protected void` `createRegistry()`
`IRemoteFilter` `createRemoteFilter(String filter)` Creates a `IRemoteFilter` object.
`IRemoteServiceReference[]` `getAllRemoteServiceReferences(String clazz, String filter)` Returns an array of `IRemoteServiceReference` objects.
`IRemoteService` `getRemoteService(IRemoteServiceReference ref)` Get remote service for given IRemoteServiceReference.
`IRemoteServiceID` `getRemoteServiceID(ID containerID, long containerRelativeID)` Get a remote service ID from a containerID and a containerRelative long value.
`Namespace` `getRemoteServiceNamespace()` Get namespace to use for this remote service provider.
`IRemoteServiceReference` `getRemoteServiceReference(IRemoteServiceID serviceID)` Get the remote service reference known to this container for the given IRemoteServiceID.
`IRemoteServiceReference[]` `getRemoteServiceReferences(ID[] idFilter, String clazz, String filter)` Returns an array of `IRemoteServiceReference` objects.
`IRemoteServiceReference[]` `getRemoteServiceReferences(ID target, ID[] idFilter, String clazz, String filter)` Returns an array of `IRemoteServiceReference` objects.
`IRemoteServiceReference[]` `getRemoteServiceReferences(ID target, String clazz, String filter)` Returns an array of `IRemoteServiceReference` objects.
`IRemoteServiceRegistration` `registerRemoteService(String[] clazzes, Object service, Dictionary properties)` Register a new remote service.
`void` `removeRemoteServiceListener(IRemoteServiceListener listener)` Remove remote service registration/unregistration listener for this container.
`void` `setConnectContextForAuthentication(IConnectContext connectContext)` Set connect context for authentication upon subsequent calls to `IRemoteServiceContainerAdapter.getRemoteServiceReferences(ID[], String, String)` or `IRemoteServiceContainerAdapter.asyncGetRemoteServiceReferences(ID[], String, String)`.
`boolean` `setRemoteServiceCallPolicy(IRemoteServiceCallPolicy policy)` Set the remote service call policy to enable authorization on remote service method calls
`boolean` `ungetRemoteService(IRemoteServiceReference ref)` Unget IRemoteServiceReference.

### Methods inherited from class org.eclipse.ecf.provider.generic.TCPClientSOContainer

`createConnection, getConnectTimeout, main`

### Methods inherited from class org.eclipse.ecf.provider.generic.ClientSOContainer

`connect, createAuthorizationCallbacks, disconnect, disconnect, dispose, forwardExcluding, forwardExcluding, forwardToRemote, getConnectData, getConnectedID, getConnection, getConnectLock, getIDForConnection, getLeaveData, handleConnectResponse, handleLeave, handleLeaveGroupMessage, handleViewChangeMessage, isConnected, isConnecting, isGroupManager, processAsynch, processDisconnect, processSynch, queueContainerMessage, sendCreate, sendCreateMsg, sendCreateResponse, sendCreateResponseSharedObjectMessage, sendCreateSharedObjectMessage, sendDispose, sendDisposeSharedObjectMessage, sendMessage, sendMessage, sendSharedObjectMessage, setConnectInitiatorPolicy`

### Methods inherited from class org.eclipse.ecf.provider.generic.SOContainer

`addNewRemoteMember, addSharedObject0, addSharedObjectAndWait, addSharedObjectWrapper, addToLoading, checkRemoteCreate, createContainerPropertiesForSharedObject, createRemoteSharedObjectConfig, createRemoteSharedObjectContext, createRemoteSharedObjectWrapper, createSharedObjectConfig, createSharedObjectContext, createSharedObjectWrapper, debug, defaultDeserializeSharedObjectMessage, defaultSerializeSharedObjectMessage, deserializeContainerMessage, deserializeSharedObjectMessage, destroySharedObject, disconnect, fireDelegateContainerEvent, forward, getAdapter, getArgsFromProperties, getArgTypesFromProperties, getClassLoaderForContainer, getClassLoaderForSharedObject, getConfig, getConnectNamespace, getGroupMemberIDs, getGroupMembershipLock, getID, getMaxGroupMembers, getMessageReceiver, getNewSharedObjectThread, getNextSequenceNumber, getOtherMemberIDs, getReceiver, getSharedObject, getSharedObjectIDs, getSharedObjectManager, getSharedObjectMessageSerializer, getSharedObjectWrapper, handleAsynchIOException, handleCreateMessage, handleCreateResponseMessage, handleSharedObjectDisposeMessage, handleSharedObjectMessage, handleUndeliveredSharedObjectMessage, handleUnidentifiedMessage, isClosing, load, moveFromLoadingToActive, notifySharedObjectActivated, notifySharedObjectDeactivated, printToSystemError, removeFromLoading, removeRemoteMember, removeSharedObject, serialize, serializeSharedObjectMessage, setMaxGroupMembers, setRemoteAddPolicy, setSharedObjectMessageSerializer, traceStack, validateContainerMessage, verifySharedObjectMessageTarget, verifyToIDForSharedObjectMessage`

### Methods inherited from class org.eclipse.ecf.core.AbstractContainer

`addListener, fireContainerEvent, getPasswordFromConnectContext, removeListener`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.eclipse.core.runtime.IAdaptable

`getAdapter`

### Methods inherited from interface org.eclipse.ecf.core.IContainer

`addListener, removeListener`

### Field Detail

#### registry

    protected IRemoteServiceContainerAdapter registry

### Constructor Detail

#### RemoteServiceContainer

    public RemoteServiceContainer(ISharedObjectContainerConfig config)

#### RemoteServiceContainer

    public RemoteServiceContainer(ISharedObjectContainerConfig config,
                                  int ka)

### Method Detail

#### createRegistry

    protected void createRegistry()

#### addRemoteServiceListener

    public void addRemoteServiceListener(IRemoteServiceListener listener)

Description copied from interface: `IRemoteServiceContainerAdapter`
Add listener for remote service registration/unregistration for this container

Specified by:
  `addRemoteServiceListener` in interface `IRemoteServiceConsumer`
Specified by:
  `addRemoteServiceListener` in interface `IRemoteServiceContainerAdapter`
Specified by:
  `addRemoteServiceListener` in interface `IRemoteServiceHost`
Parameters:
  `listener` - notified of service registration/unregistration events. Must not be `null` .

#### getRemoteService

    public IRemoteService getRemoteService(IRemoteServiceReference ref)

Description copied from interface: `IRemoteServiceContainerAdapter`
Get remote service for given IRemoteServiceReference. Note that clients that call this method successfully should later call `IRemoteServiceContainerAdapter.ungetRemoteService(IRemoteServiceReference)` when the IRemoteService will no longer be used.

Specified by:
  `getRemoteService` in interface `IRemoteServiceConsumer`
Specified by:
  `getRemoteService` in interface `IRemoteServiceContainerAdapter`
Parameters:
  `ref` - the IRemoteServiceReference for the desired service. Must not be `null` .
Returns:
  IRemoteService representing the remote service. If remote service no longer exists for reference, then `null` is returned.
See Also:
  `IRemoteServiceContainerAdapter.ungetRemoteService(IRemoteServiceReference)`

#### getRemoteServiceReferences

    public IRemoteServiceReference[] getRemoteServiceReferences(ID[] idFilter,
                                                                String clazz,
                                                                String filter)
                                                         throws InvalidSyntaxException

Description copied from interface: `IRemoteServiceContainerAdapter`
Returns an array of `IRemoteServiceReference` objects. The returned array of `IRemoteServiceReference` objects contains services that were registered under the specified class and match the specified idFilter, and filter criteria.

Note this method assumes that the enclosing container has previously been connected, and uses the idFilter to filter among targets within the previously connected set of container IDs. To request connection as part of reference lookup, see `IRemoteServiceContainerAdapter.getRemoteServiceReferences(ID, String, String)`.

The list is valid at the time of the call to this method, however since the Framework is a very dynamic environment, services can be modified or unregistered at anytime.

`idFilter` is used to select a registered services that were registered by a given set of containers with id in idFilter. Only services exposed by a container with id in idFilter will be returned.

If `idFilter` is `null`, all containers are considered to match the filter.

`filter` is used to select the registered service whose properties objects contain keys and values which satisfy the filter. See `Filter` for a description of the filter string syntax.

If `filter` is `null`, all registered services are considered to match the filter. If `filter` cannot be parsed, an `InvalidSyntaxException` will be thrown with a human readable message where the filter became unparsable.

Specified by:
  `getRemoteServiceReferences` in interface `IRemoteServiceConsumer`
Specified by:
  `getRemoteServiceReferences` in interface `IRemoteServiceContainerAdapter`
Parameters:
  `idFilter` - an array of ID instances that will restrict the search for matching container ids If null, all remote containers will be considered in search for matching IRemoteServiceReference instances. May be `null`.
  `clazz` - the fully qualified name of the interface class that describes the desired service. Must not be `null`.
  `filter` - The filter criteria. May be `null`.
Returns:
  Array of IRemoteServiceReferences matching given search criteria or `null` if no services are found that match the search.
Throws:
  `InvalidSyntaxException` - If filter contains an invalid filter string that cannot be parsed.

#### registerRemoteService

    public IRemoteServiceRegistration registerRemoteService(String[] clazzes,
                                                            Object service,
                                                            Dictionary properties)

Description copied from interface: `IRemoteServiceContainerAdapter`
Register a new remote service. This method is to be called by the service server...i.e. the client that wishes to make available a service to other client within this container.

Specified by:
  `registerRemoteService` in interface `IRemoteServiceContainerAdapter`
Specified by:
  `registerRemoteService` in interface `IRemoteServiceHost`
Parameters:
  `clazzes` - the interface classes that the service exposes to remote clients. Must not be `null` and must not be an empty array.
  `service` - the service object. Under normal conditions this object must
  - not be `null`
  - implement all of the classes specified by the first parameter
  The only situation when the service object may be `null` is if the service property `Constants.SERVICE_REGISTER_PROXY` is set in the properties. If `Constants.SERVICE_REGISTER_PROXY` is set in the properties parameter (to an arbitrary value), then the service object may then be `null`.
  `properties` - to be associated with service
Returns:
  IRemoteServiceRegistration the service registration. Will not return `null` .

#### removeRemoteServiceListener

    public void removeRemoteServiceListener(IRemoteServiceListener listener)

Description copied from interface: `IRemoteServiceContainerAdapter`
Remove remote service registration/unregistration listener for this container.

Specified by:
  `removeRemoteServiceListener` in interface `IRemoteServiceConsumer`
Specified by:
  `removeRemoteServiceListener` in interface `IRemoteServiceContainerAdapter`
Specified by:
  `removeRemoteServiceListener` in interface `IRemoteServiceHost`
Parameters:
  `listener` - to remove. Must not be `null` .

#### ungetRemoteService

    public boolean ungetRemoteService(IRemoteServiceReference ref)

Description copied from interface: `IRemoteServiceContainerAdapter`
Unget IRemoteServiceReference. Release all resources associated with the given IRemoteServiceReference. This method should be called by users of the IRemoteServiceReference that have previously called `IRemoteServiceContainerAdapter.getRemoteService(IRemoteServiceReference)`. If this method returns true, then the previously used IRemoteService will no longer be usable.

Specified by:
  `ungetRemoteService` in interface `IRemoteServiceConsumer`
Specified by:
  `ungetRemoteService` in interface `IRemoteServiceContainerAdapter`
Parameters:
  `ref` - the IRemoteServiceReference to unget
Returns:
  true if unget successful, false if not. If this method returns true, then the IRemoteService instance previously retrieved via the given IRemoteServiceReference instance provided will no longer be usable.
See Also:
  `IRemoteServiceContainerAdapter.getRemoteService(IRemoteServiceReference)`

#### asyncGetRemoteServiceReferences

    public org.eclipse.equinox.concurrent.future.IFuture asyncGetRemoteServiceReferences(ID[] idFilter,
                                                                                         String clazz,
                                                                                         String filter)

Description copied from interface: `IRemoteServiceContainerAdapter`
Asynchronously returns an array of `IRemoteServiceReference` objects. The returned array of `IRemoteServiceReference` objects contains services that were registered under the specified class and match the specified idFilter, and filter criteria.

Note this method assumes that the enclosing container has previously been connected, and uses the idFilter to filter among targets within the previously connected set of container IDs. To request connection as part of reference lookup, see `IRemoteServiceContainerAdapter.getRemoteServiceReferences(ID, String, String)`.

The IFuture is returned immediately, and subsequent calls to `IFuture.get()` or `IFuture.get(long)` will return the actual results received. The type of the Object returned from `IFuture.get()` will be IRemoteServiceReference [].

The list is valid at the time of the call to this method, however since the Framework is a very dynamic environment, services can be modified or unregistered at anytime.

`idFilter` is used to select a registered services that were registered by a given set of containers with id in idFilter. Only services exposed by a container with id in idFilter will be returned.

If `idFilter` is `null`, all containers are considered to match the filter.

`filter` is used to select the registered service whose properties objects contain keys and values which satisfy the filter. See `Filter` for a description of the filter string syntax.

Specified by:
  `asyncGetRemoteServiceReferences` in interface `IRemoteServiceConsumer`
Specified by:
  `asyncGetRemoteServiceReferences` in interface `IRemoteServiceContainerAdapter`
Parameters:
  `idFilter` - an array of ID instances that will restrict the search for matching container ids If null, all remote containers will be considered in search for matching IRemoteServiceReference instances. May be `null`.
  `clazz` - the fully qualified name of the interface class that describes the desired service. Must not be `null`.
  `filter` - The filter criteria. May be `null`.
Returns:
  IFuture that through subsequent calls to IFuture#get() will return IRemoteServiceReference [] with IRemoteServiceReferences matching given search criteria. Will not return `null`.
Since:
  3.0

#### getRemoteServiceNamespace

    public Namespace getRemoteServiceNamespace()

Description copied from interface: `IRemoteServiceContainerAdapter`
Get namespace to use for this remote service provider.

Specified by:
  `getRemoteServiceNamespace` in interface `IRemoteServiceConsumer`
Specified by:
  `getRemoteServiceNamespace` in interface `IRemoteServiceContainerAdapter`
Specified by:
  `getRemoteServiceNamespace` in interface `IRemoteServiceHost`
Returns:
  Namespace to use for creating IRemoteServiceID for this remote service provider. Will not return `null`.
Since:
  3.0

#### createRemoteFilter

    public IRemoteFilter createRemoteFilter(String filter)
                                     throws InvalidSyntaxException

Description copied from interface: `IRemoteServiceContainerAdapter`
Creates a `IRemoteFilter` object. This `IRemoteFilter` object may be used to match a `IRemoteServiceReference` object or a `Dictionary` object.

If the filter cannot be parsed, an `InvalidSyntaxException` will be thrown with a human readable message where the filter became unparsable.

Specified by:
  `createRemoteFilter` in interface `IRemoteServiceConsumer`
Specified by:
  `createRemoteFilter` in interface `IRemoteServiceContainerAdapter`
Parameters:
  `filter` - The filter string.
Returns:
  A `IRemoteFilter` object encapsulating the filter string.
Throws:
  `InvalidSyntaxException` - If `filter` contains an invalid filter string that cannot be parsed.
Since:
  3.0
See Also:
  "Framework specification for a description of the filter string syntax.", `FrameworkUtil.createFilter(String)`

#### getRemoteServiceReference

    public IRemoteServiceReference getRemoteServiceReference(IRemoteServiceID serviceID)

Description copied from interface: `IRemoteServiceContainerAdapter`
Get the remote service reference known to this container for the given IRemoteServiceID. Note that this method must be guaranteed not to block by the provider implementation.

Specified by:
  `getRemoteServiceReference` in interface `IRemoteServiceConsumer`
Specified by:
  `getRemoteServiceReference` in interface `IRemoteServiceContainerAdapter`
Parameters:
  `serviceID` - the serviceID to retrieve the IRemoteServiceReference for.
Returns:
  IRemoteServiceReference the remote service reference associated with the given serviceID. Will return `null` if no IRemoteServiceReference found for the given serviceID.
Since:
  3.0

#### getRemoteServiceID

    public IRemoteServiceID getRemoteServiceID(ID containerID,
                                               long containerRelativeID)

Description copied from interface: `IRemoteServiceContainerAdapter`
Get a remote service ID from a containerID and a containerRelative long value. Will return a non-null value if the IRemoteServiceRegistration/Reference is currently 'known' to this container adapter. `null` if not.

Specified by:
  `getRemoteServiceID` in interface `IRemoteServiceConsumer`
Specified by:
  `getRemoteServiceID` in interface `IRemoteServiceContainerAdapter`
Specified by:
  `getRemoteServiceID` in interface `IRemoteServiceHost`
Parameters:
  `containerID` - the containerID that is the server/host for the remote service. Must not be `null`. This must be the containerID for the server/host of the remote service.
  `containerRelativeID` - the long value identifying the remote service relative to the container ID.
Returns:
  IRemoteServiceID instance if the associated IRemoteServiceRegistration/Reference is known to this container adapter, `null` if it is not.
Since:
  3.0

#### setConnectContextForAuthentication

    public void setConnectContextForAuthentication(IConnectContext connectContext)

Description copied from interface: `IRemoteServiceContainerAdapter`
Set connect context for authentication upon subsequent calls to `IRemoteServiceContainerAdapter.getRemoteServiceReferences(ID[], String, String)` or `IRemoteServiceContainerAdapter.asyncGetRemoteServiceReferences(ID[], String, String)`. This method should be called with a non-null connectContext in order to allow authentication to occur during.

Specified by:
  `setConnectContextForAuthentication` in interface `IRemoteServiceConsumer`
Specified by:
  `setConnectContextForAuthentication` in interface `IRemoteServiceContainerAdapter`
Parameters:
  `connectContext` - the connect context to use for authenticating. If `null`, then no authentication will be attempted.
Since:
  3.0

#### getRemoteServiceReferences

    public IRemoteServiceReference[] getRemoteServiceReferences(ID target,
                                                                String clazz,
                                                                String filter)
                                                         throws InvalidSyntaxException,
                                                                ContainerConnectException

Description copied from interface: `IRemoteServiceContainerAdapter`

Returns an array of `IRemoteServiceReference` objects. The returned array of `IRemoteServiceReference` objects contains services that were registered under the specified class and match the specified idFilter, and filter criteria.

The list is valid at the time of the call to this method, however since the Framework is a very dynamic environment, services can be modified or unregistered at anytime.

target is a remote container to connect to.

`filter` is used to select the registered service whose properties objects contain keys and values which satisfy the filter. See `Filter` for a description of the filter string syntax.

If `filter` is `null`, all registered services are considered to match the filter. If `filter` cannot be parsed, an `InvalidSyntaxException` will be thrown with a human readable message where the filter became unparsable.

Specified by:
  `getRemoteServiceReferences` in interface `IRemoteServiceConsumer`
Specified by:
  `getRemoteServiceReferences` in interface `IRemoteServiceContainerAdapter`
Parameters:
  `target` - an target to connect to if enclosing container is not already connected. May be `null`.
  `clazz` - the fully qualified name of the interface class that describes the desired service. Must not be `null`.
  `filter` - The filter criteria. May be `null`.
Returns:
  Array of IRemoteServiceReferences matching given search criteria or `null` if no services are found that match the search.
Throws:
  `InvalidSyntaxException` - If filter contains an invalid filter string that cannot be parsed.
  `ContainerConnectException` - if container cannot connect
Since:
  3.0

#### asyncGetRemoteServiceReferences

    public org.eclipse.equinox.concurrent.future.IFuture asyncGetRemoteServiceReferences(ID target,
                                                                                         String clazz,
                                                                                         String filter)

Description copied from interface: `IRemoteServiceContainerAdapter`
Asynchronously returns an array of `IRemoteServiceReference` objects. The returned array of `IRemoteServiceReference` objects contains services that were registered under the specified class and match the specified idFilter, and filter criteria.

The IFuture is returned immediately, and subsequent calls to `IFuture.get()` or `IFuture.get(long)` will return the actual results received. The type of the Object returned from `IFuture.get()` will be IRemoteServiceReference [].

The list is valid at the time of the call to this method, however since the Framework is a very dynamic environment, services can be modified or unregistered at anytime.

`idFilter` is used to select a registered services that were registered by a given set of containers with id in idFilter. Only services exposed by a container with id in idFilter will be returned.

target is a remote container to connect to.

`filter` is used to select the registered service whose properties objects contain keys and values which satisfy the filter. See `Filter` for a description of the filter string syntax.

Specified by:
  `asyncGetRemoteServiceReferences` in interface `IRemoteServiceConsumer`
Specified by:
  `asyncGetRemoteServiceReferences` in interface `IRemoteServiceContainerAdapter`
Parameters:
  `target` - an target to connect to if enclosing container is not already connected. May be `null`.
  `clazz` - the fully qualified name of the interface class that describes the desired service. Must not be `null`.
  `filter` - The filter criteria. May be `null`.
Returns:
  IFuture that through subsequent calls to IFuture#get() will return IRemoteServiceReference [] with IRemoteServiceReferences matching given search criteria. Will not return `null`.
Since:
  3.0

#### getAllRemoteServiceReferences

    public IRemoteServiceReference[] getAllRemoteServiceReferences(String clazz,
                                                                   String filter)
                                                            throws InvalidSyntaxException

Description copied from interface: `IRemoteServiceContainerAdapter`

Returns an array of `IRemoteServiceReference` objects. The returned array of `IRemoteServiceReference` objects contains services that were registered under the specified class, or if the clazz parameter is `null` all services registered.

The list is valid at the time of the call to this method, however since the remote service container is a very dynamic environment, services can be modified or unregistered at anytime.

`filter` is used to select the registered service whose properties objects contain keys and values which satisfy the filter. See `Filter` for a description of the filter string syntax.

If `filter` is `null`, all registered services are considered to match the filter. If `filter` cannot be parsed, an `InvalidSyntaxException` will be thrown with a human readable message where the filter became unparsable.

Specified by:
  `getAllRemoteServiceReferences` in interface `IRemoteServiceConsumer`
Specified by:
  `getAllRemoteServiceReferences` in interface `IRemoteServiceContainerAdapter`
Parameters:
  `clazz` - the fully qualified name of the interface class that describes the desired service. May be `null`.
  `filter` - The filter criteria. May be `null`.
Returns:
  Array of IRemoteServiceReferences matching given search criteria or `null` if no services are found that match the search.
Throws:
  `InvalidSyntaxException` - If filter contains an invalid filter string that cannot be parsed.
Since:
  3.0

#### getRemoteServiceReferences

    public IRemoteServiceReference[] getRemoteServiceReferences(ID target,
                                                                ID[] idFilter,
                                                                String clazz,
                                                                String filter)
                                                         throws InvalidSyntaxException,
                                                                ContainerConnectException

Description copied from interface: `IRemoteServiceContainerAdapter`
Returns an array of `IRemoteServiceReference` objects. The returned array of `IRemoteServiceReference` objects contains services that were registered under the specified class and match the specified idFilter, and filter criteria.

Note this method assumes that the enclosing container has previously been connected, and uses the idFilter to filter among targets within the previously connected set of container IDs. To request connection as part of reference lookup, see `IRemoteServiceContainerAdapter.getRemoteServiceReferences(ID, String, String)`.

The list is valid at the time of the call to this method, however since the Framework is a very dynamic environment, services can be modified or unregistered at anytime.

`target` is a remote container to connect to. If `null`, no connection attempt is made.

`idFilter` is used to select a registered services that were registered by a given set of containers with id in idFilter. Only services exposed by a container with id in idFilter will be returned. If `idFilter` is `null`, all containers are considered to match the filter.

`filter` is used to select the registered service whose properties objects contain keys and values which satisfy the filter. See `Filter` for a description of the filter string syntax. If `filter` is `null`, all registered services are considered to match the filter. If `filter` cannot be parsed, an `InvalidSyntaxException` will be thrown with a human readable message where the filter became unparsable.

Specified by:
  `getRemoteServiceReferences` in interface `IRemoteServiceConsumer`
Specified by:
  `getRemoteServiceReferences` in interface `IRemoteServiceContainerAdapter`
Parameters:
  `target` - a target container to connect to if enclosing container is not already connected. May be `null`.
  `idFilter` - an array of ID instances that will restrict the search for matching container ids If null, all remote containers will be considered in search for matching IRemoteServiceReference instances. May be `null`.
  `clazz` - the fully qualified name of the interface class that describes the desired service. Must not be `null`.
  `filter` - The filter criteria. May be `null`.
Returns:
  Array of IRemoteServiceReferences matching given search criteria or `null` if no services are found that match the search.
Throws:
  `InvalidSyntaxException` - If filter contains an invalid filter string that cannot be parsed.
  `ContainerConnectException` - if container cannot connect
Since:
  3.4

#### asyncGetRemoteServiceReferences

    public org.eclipse.equinox.concurrent.future.IFuture asyncGetRemoteServiceReferences(ID target,
                                                                                         ID[] idFilter,
                                                                                         String clazz,
                                                                                         String filter)

Description copied from interface: `IRemoteServiceContainerAdapter`
Asynchronously returns an array of `IRemoteServiceReference` objects. The returned array of `IRemoteServiceReference` objects contains services that were registered under the specified class and match the specified idFilter, and filter criteria.

The IFuture is returned immediately, and subsequent calls to `IFuture.get()` or `IFuture.get(long)` will return the actual results received. The type of the Object returned from `IFuture.get()` will be IRemoteServiceReference [].

The list is valid at the time of the call to this method, however since the Framework is a very dynamic environment, services can be modified or unregistered at anytime.

`target` is a remote container to connect to. If `null`, no connection attempt is made.

`idFilter` is used to select a registered services that were registered by a given set of containers with id in idFilter. Only services exposed by a container with id in idFilter will be returned. If `idFilter` is `null`, all containers are considered to match the filter.

`filter` is used to select the registered service whose properties objects contain keys and values which satisfy the filter. See `Filter` for a description of the filter string syntax. If `filter` is `null`, all registered services are considered to match the filter. If `filter` cannot be parsed, an `InvalidSyntaxException` will be thrown with a human readable message where the filter became unparsable.

Specified by:
  `asyncGetRemoteServiceReferences` in interface `IRemoteServiceConsumer`
Specified by:
  `asyncGetRemoteServiceReferences` in interface `IRemoteServiceContainerAdapter`
Parameters:
  `target` - an target to connect to if enclosing container is not already connected. May be `null`.
  `idFilter` - an array of ID instances that will restrict the search for matching container ids If null, all remote containers will be considered in search for matching IRemoteServiceReference instances. May be `null`.
  `clazz` - the fully qualified name of the interface class that describes the desired service. Must not be `null`.
  `filter` - The filter criteria. May be `null`.
Returns:
  IFuture that through subsequent calls to IFuture#get() will return IRemoteServiceReference [] with IRemoteServiceReferences matching given search criteria. Will not return `null`.
Since:
  3.4

#### setRemoteServiceCallPolicy

    public boolean setRemoteServiceCallPolicy(IRemoteServiceCallPolicy policy)

Description copied from interface: `IRemoteServiceContainerAdapter`
Set the remote service call policy to enable authorization on remote service method calls

Specified by:
  `setRemoteServiceCallPolicy` in interface `IRemoteServiceContainerAdapter`
Parameters:
  `policy` - Implementation of `IRemoteServiceCallPolicy` containing authorization specific code
Returns:
  `true` if the underlying provider supports using the policy, `false` if it does not support using the policy.
Since:
  4.0